<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
	<title>API: element   AttributeProvider.js  (YUI Library)</title>
	<link rel="stylesheet" type="text/css" href="assets/api.css">
</head>

<body id="yahoo-com">
<div id="doc3" class="yui-t2">

	<div id="hd">
        <h1>Yahoo! UI Library</h1>
        <h3>element&nbsp; <span class="subtitle">2.2.0</span></h3>
        <p>
        <a href="./index.html">Yahoo! UI Library</a> 
            &gt; <a href="./module_element.html">element</a>
                
                 &gt; AttributeProvider.js (source view) 
            </p>
	</div>

	<div id="bd">
		<div id="yui-main">
			<div class="yui-b">

                    <div id="srcout">
<div class="highlight" ><pre><span class="o">(</span><span class="k">function</span><span class="o">()</span> <span class="o">{</span>
    <span class="k">var</span> <span class="nx">Lang</span> <span class="o">=</span> <span class="nx">YAHOO</span><span class="o">.</span><span class="nx">util</span><span class="o">.</span><span class="nx">Lang</span><span class="o">;</span>

    <span class="c">/*</span>
<span class="c">    Copyright (c) 2006, Yahoo! Inc. All rights reserved.</span>
<span class="c">    Code licensed under the BSD License:</span>
<span class="c">    http://developer.yahoo.net/yui/license.txt</span>
<span class="c">    */</span>
    
    <span class="c">/**</span>
<span class="c">     * Provides and manages YAHOO.util.Attribute instances</span>
<span class="c">     * @namespace YAHOO.util</span>
<span class="c">     * @class AttributeProvider</span>
<span class="c">     * @uses YAHOO.util.EventProvider</span>
<span class="c">     */</span>
    <span class="nx">YAHOO</span><span class="o">.</span><span class="nx">util</span><span class="o">.</span><span class="nx">AttributeProvider</span> <span class="o">=</span> <span class="k">function</span><span class="o">()</span> <span class="o">{};</span>
    
    <span class="nx">YAHOO</span><span class="o">.</span><span class="nx">util</span><span class="o">.</span><span class="nx">AttributeProvider</span><span class="o">.</span><span class="nx">prototype</span> <span class="o">=</span> <span class="o">{</span>
        
        <span class="c">/**</span>
<span class="c">         * A key-value map of Attribute configurations</span>
<span class="c">         * @property _configs</span>
<span class="c">         * @protected (may be used by subclasses and augmentors)</span>
<span class="c">         * @private</span>
<span class="c">         * @type {Object}</span>
<span class="c">         */</span>
        <span class="nx">_configs</span><span class="o">:</span> <span class="kc">null</span><span class="o">,</span>
        <span class="c">/**</span>
<span class="c">         * Returns the current value of the attribute.</span>
<span class="c">         * @method get</span>
<span class="c">         * @param {String} key The attribute whose value will be returned.</span>
<span class="c">         */</span>
        <span class="nx">get</span><span class="o">:</span> <span class="k">function</span><span class="o">(</span><span class="nx">key</span><span class="o">){</span>
            <span class="k">var</span> <span class="nx">configs</span> <span class="o">=</span> <span class="k">this</span><span class="o">.</span><span class="nx">_configs</span> <span class="o">||</span> <span class="o">{};</span>
            <span class="k">var</span> <span class="nx">config</span> <span class="o">=</span> <span class="nx">configs</span><span class="o">[</span><span class="nx">key</span><span class="o">];</span>
            
            <span class="k">if</span> <span class="o">(!</span><span class="nx">config</span><span class="o">)</span> <span class="o">{</span>
                <span class="nx">YAHOO</span><span class="o">.</span><span class="nx">log</span><span class="o">(</span><span class="nx">key</span> <span class="o">+</span> <span class="s1">&#39; not found&#39;</span><span class="o">,</span> <span class="s1">&#39;error&#39;</span><span class="o">,</span> <span class="s1">&#39;AttributeProvider&#39;</span><span class="o">);</span>
                <span class="k">return</span> <span class="kc">undefined</span><span class="o">;</span>
            <span class="o">}</span>
            
            <span class="k">return</span> <span class="nx">config</span><span class="o">.</span><span class="nx">value</span><span class="o">;</span>
        <span class="o">},</span>
        
        <span class="c">/**</span>
<span class="c">         * Sets the value of a config.</span>
<span class="c">         * @method set</span>
<span class="c">         * @param {String} key The name of the attribute</span>
<span class="c">         * @param {Any} value The value to apply to the attribute</span>
<span class="c">         * @param {Boolean} silent Whether or not to suppress change events</span>
<span class="c">         * @return {Boolean} Whether or not the value was set.</span>
<span class="c">         */</span>
        <span class="nx">set</span><span class="o">:</span> <span class="k">function</span><span class="o">(</span><span class="nx">key</span><span class="o">,</span> <span class="nx">value</span><span class="o">,</span> <span class="nx">silent</span><span class="o">){</span>
            <span class="k">var</span> <span class="nx">configs</span> <span class="o">=</span> <span class="k">this</span><span class="o">.</span><span class="nx">_configs</span> <span class="o">||</span> <span class="o">{};</span>
            <span class="k">var</span> <span class="nx">config</span> <span class="o">=</span> <span class="nx">configs</span><span class="o">[</span><span class="nx">key</span><span class="o">];</span>
            
            <span class="k">if</span> <span class="o">(!</span><span class="nx">config</span><span class="o">)</span> <span class="o">{</span>
                <span class="nx">YAHOO</span><span class="o">.</span><span class="nx">log</span><span class="o">(</span><span class="s1">&#39;set failed: &#39;</span> <span class="o">+</span> <span class="nx">key</span> <span class="o">+</span> <span class="s1">&#39; not found&#39;</span><span class="o">,</span>
                        <span class="s1">&#39;error&#39;</span><span class="o">,</span> <span class="s1">&#39;AttributeProvider&#39;</span><span class="o">);</span>
                <span class="k">return</span> <span class="kc">false</span><span class="o">;</span>
            <span class="o">}</span>
            
            <span class="k">return</span> <span class="nx">config</span><span class="o">.</span><span class="nx">setValue</span><span class="o">(</span><span class="nx">value</span><span class="o">,</span> <span class="nx">silent</span><span class="o">);</span>
        <span class="o">},</span>
    
        <span class="c">/**</span>
<span class="c">         * Returns an array of attribute names.</span>
<span class="c">         * @method getAttributeKeys</span>
<span class="c">         * @return {Array} An array of attribute names.</span>
<span class="c">         */</span>
        <span class="nx">getAttributeKeys</span><span class="o">:</span> <span class="k">function</span><span class="o">(){</span>
            <span class="k">var</span> <span class="nx">configs</span> <span class="o">=</span> <span class="k">this</span><span class="o">.</span><span class="nx">_configs</span><span class="o">;</span>
            <span class="k">var</span> <span class="nx">keys</span> <span class="o">=</span> <span class="o">[];</span>
            <span class="k">var</span> <span class="nx">config</span><span class="o">;</span>
            <span class="k">for</span> <span class="o">(</span><span class="k">var</span> <span class="nx">key</span> <span class="k">in</span> <span class="nx">configs</span><span class="o">)</span> <span class="o">{</span>
                <span class="nx">config</span> <span class="o">=</span> <span class="nx">configs</span><span class="o">[</span><span class="nx">key</span><span class="o">];</span>
                <span class="k">if</span> <span class="o">(</span> <span class="nx">Lang</span><span class="o">.</span><span class="nx">hasOwnProperty</span><span class="o">(</span><span class="nx">configs</span><span class="o">,</span> <span class="nx">key</span><span class="o">)</span> <span class="o">&amp;&amp;</span> 
                        <span class="o">!</span><span class="nx">Lang</span><span class="o">.</span><span class="nx">isUndefined</span><span class="o">(</span><span class="nx">config</span><span class="o">)</span> <span class="o">)</span> <span class="o">{</span>
                    <span class="nx">keys</span><span class="o">[</span><span class="nx">keys</span><span class="o">.</span><span class="nx">length</span><span class="o">]</span> <span class="o">=</span> <span class="nx">key</span><span class="o">;</span>
                <span class="o">}</span>
            <span class="o">}</span>
            
            <span class="k">return</span> <span class="nx">keys</span><span class="o">;</span>
        <span class="o">},</span>
        
        <span class="c">/**</span>
<span class="c">         * Sets multiple attribute values.</span>
<span class="c">         * @method setAttributes</span>
<span class="c">         * @param {Object} map  A key-value map of attributes</span>
<span class="c">         * @param {Boolean} silent Whether or not to suppress change events</span>
<span class="c">         */</span>
        <span class="nx">setAttributes</span><span class="o">:</span> <span class="k">function</span><span class="o">(</span><span class="nx">map</span><span class="o">,</span> <span class="nx">silent</span><span class="o">){</span>
            <span class="k">for</span> <span class="o">(</span><span class="k">var</span> <span class="nx">key</span> <span class="k">in</span> <span class="nx">map</span><span class="o">)</span> <span class="o">{</span>
                <span class="k">if</span> <span class="o">(</span> <span class="nx">Lang</span><span class="o">.</span><span class="nx">hasOwnProperty</span><span class="o">(</span><span class="nx">map</span><span class="o">,</span> <span class="nx">key</span><span class="o">)</span> <span class="o">)</span> <span class="o">{</span>
                    <span class="k">this</span><span class="o">.</span><span class="nx">set</span><span class="o">(</span><span class="nx">key</span><span class="o">,</span> <span class="nx">map</span><span class="o">[</span><span class="nx">key</span><span class="o">],</span> <span class="nx">silent</span><span class="o">);</span>
                <span class="o">}</span>
            <span class="o">}</span>
        <span class="o">},</span>
    
        <span class="c">/**</span>
<span class="c">         * Resets the specified attribute&#39;s value to its initial value.</span>
<span class="c">         * @method resetValue</span>
<span class="c">         * @param {String} key The name of the attribute</span>
<span class="c">         * @param {Boolean} silent Whether or not to suppress change events</span>
<span class="c">         * @return {Boolean} Whether or not the value was set</span>
<span class="c">         */</span>
        <span class="nx">resetValue</span><span class="o">:</span> <span class="k">function</span><span class="o">(</span><span class="nx">key</span><span class="o">,</span> <span class="nx">silent</span><span class="o">){</span>
            <span class="k">var</span> <span class="nx">configs</span> <span class="o">=</span> <span class="k">this</span><span class="o">.</span><span class="nx">_configs</span> <span class="o">||</span> <span class="o">{};</span>
            <span class="k">if</span> <span class="o">(</span><span class="nx">configs</span><span class="o">[</span><span class="nx">key</span><span class="o">])</span> <span class="o">{</span>
                <span class="k">this</span><span class="o">.</span><span class="nx">set</span><span class="o">(</span><span class="nx">key</span><span class="o">,</span> <span class="nx">configs</span><span class="o">[</span><span class="nx">key</span><span class="o">].</span><span class="nx">_initialConfig</span><span class="o">.</span><span class="nx">value</span><span class="o">,</span> <span class="nx">silent</span><span class="o">);</span>
                <span class="k">return</span> <span class="kc">true</span><span class="o">;</span>
            <span class="o">}</span>
            <span class="k">return</span> <span class="kc">false</span><span class="o">;</span>
        <span class="o">},</span>
    
        <span class="c">/**</span>
<span class="c">         * Sets the attribute&#39;s value to its current value.</span>
<span class="c">         * @method refresh</span>
<span class="c">         * @param {String | Array} key The attribute(s) to refresh</span>
<span class="c">         * @param {Boolean} silent Whether or not to suppress change events</span>
<span class="c">         */</span>
        <span class="nx">refresh</span><span class="o">:</span> <span class="k">function</span><span class="o">(</span><span class="nx">key</span><span class="o">,</span> <span class="nx">silent</span><span class="o">){</span>
            <span class="k">var</span> <span class="nx">configs</span> <span class="o">=</span> <span class="k">this</span><span class="o">.</span><span class="nx">_configs</span><span class="o">;</span>
            
            <span class="nx">key</span> <span class="o">=</span> <span class="o">(</span> <span class="o">(</span> <span class="nx">Lang</span><span class="o">.</span><span class="nx">isString</span><span class="o">(</span><span class="nx">key</span><span class="o">)</span> <span class="o">)</span> <span class="o">?</span> <span class="o">[</span><span class="nx">key</span><span class="o">]</span> <span class="o">:</span> <span class="nx">key</span> <span class="o">)</span> <span class="o">||</span> 
                    <span class="k">this</span><span class="o">.</span><span class="nx">getAttributeKeys</span><span class="o">();</span>
            
            <span class="k">for</span> <span class="o">(</span><span class="k">var</span> <span class="nx">i</span> <span class="o">=</span> <span class="m">0</span><span class="o">,</span> <span class="nx">len</span> <span class="o">=</span> <span class="nx">key</span><span class="o">.</span><span class="nx">length</span><span class="o">;</span> <span class="nx">i</span> <span class="o">&lt;</span> <span class="nx">len</span><span class="o">;</span> <span class="o">++</span><span class="nx">i</span><span class="o">)</span> <span class="o">{</span> 
                <span class="k">if</span> <span class="o">(</span> <span class="c">// only set if there is a value and not null</span>
<span class="c"></span>                    <span class="nx">configs</span><span class="o">[</span><span class="nx">key</span><span class="o">[</span><span class="nx">i</span><span class="o">]]</span> <span class="o">&amp;&amp;</span> 
                    <span class="o">!</span> <span class="nx">Lang</span><span class="o">.</span><span class="nx">isUndefined</span><span class="o">(</span><span class="nx">configs</span><span class="o">[</span><span class="nx">key</span><span class="o">[</span><span class="nx">i</span><span class="o">]].</span><span class="nx">value</span><span class="o">)</span> <span class="o">&amp;&amp;</span>
                    <span class="o">!</span> <span class="nx">Lang</span><span class="o">.</span><span class="nx">isNull</span><span class="o">(</span><span class="nx">configs</span><span class="o">[</span><span class="nx">key</span><span class="o">[</span><span class="nx">i</span><span class="o">]].</span><span class="nx">value</span><span class="o">)</span> <span class="o">)</span> <span class="o">{</span>
                    <span class="nx">configs</span><span class="o">[</span><span class="nx">key</span><span class="o">[</span><span class="nx">i</span><span class="o">]].</span><span class="nx">refresh</span><span class="o">(</span><span class="nx">silent</span><span class="o">);</span>
                <span class="o">}</span>
            <span class="o">}</span>
        <span class="o">},</span>
    
        <span class="c">/**</span>
<span class="c">         * Adds an Attribute to the AttributeProvider instance. </span>
<span class="c">         * @method register</span>
<span class="c">         * @param {String} key The attribute&#39;s name</span>
<span class="c">         * @param {Object} map A key-value map containing the</span>
<span class="c">         * attribute&#39;s properties.</span>
<span class="c">         * @deprecated Use setAttributeConfig</span>
<span class="c">         */</span>
        <span class="nx">register</span><span class="o">:</span> <span class="k">function</span><span class="o">(</span><span class="nx">key</span><span class="o">,</span> <span class="nx">map</span><span class="o">)</span> <span class="o">{</span>
            <span class="k">this</span><span class="o">.</span><span class="nx">setAttributeConfig</span><span class="o">(</span><span class="nx">key</span><span class="o">,</span> <span class="nx">map</span><span class="o">);</span>
        <span class="o">},</span>
        
        
        <span class="c">/**</span>
<span class="c">         * Returns the attribute&#39;s properties.</span>
<span class="c">         * @method getAttributeConfig</span>
<span class="c">         * @param {String} key The attribute&#39;s name</span>
<span class="c">         * @private</span>
<span class="c">         * @return {object} A key-value map containing all of the</span>
<span class="c">         * attribute&#39;s properties.</span>
<span class="c">         */</span>
        <span class="nx">getAttributeConfig</span><span class="o">:</span> <span class="k">function</span><span class="o">(</span><span class="nx">key</span><span class="o">)</span> <span class="o">{</span>
            <span class="k">var</span> <span class="nx">configs</span> <span class="o">=</span> <span class="k">this</span><span class="o">.</span><span class="nx">_configs</span> <span class="o">||</span> <span class="o">{};</span>
            <span class="k">var</span> <span class="nx">config</span> <span class="o">=</span> <span class="nx">configs</span><span class="o">[</span><span class="nx">key</span><span class="o">]</span> <span class="o">||</span> <span class="o">{};</span>
            <span class="k">var</span> <span class="nx">map</span> <span class="o">=</span> <span class="o">{};</span> <span class="c">// returning a copy to prevent overrides</span>
<span class="c"></span>            
            <span class="k">for</span> <span class="o">(</span><span class="nx">key</span> <span class="k">in</span> <span class="nx">config</span><span class="o">)</span> <span class="o">{</span>
                <span class="k">if</span> <span class="o">(</span> <span class="nx">Lang</span><span class="o">.</span><span class="nx">hasOwnProperty</span><span class="o">(</span><span class="nx">config</span><span class="o">,</span> <span class="nx">key</span><span class="o">)</span> <span class="o">)</span> <span class="o">{</span>
                    <span class="nx">map</span><span class="o">[</span><span class="nx">key</span><span class="o">]</span> <span class="o">=</span> <span class="nx">config</span><span class="o">[</span><span class="nx">key</span><span class="o">];</span>
                <span class="o">}</span>
            <span class="o">}</span>
    
            <span class="k">return</span> <span class="nx">map</span><span class="o">;</span>
        <span class="o">},</span>
        
        <span class="c">/**</span>
<span class="c">         * Sets or updates an Attribute instance&#39;s properties. </span>
<span class="c">         * @method setAttributeConfig</span>
<span class="c">         * @param {String} key The attribute&#39;s name.</span>
<span class="c">         * @param {Object} map A key-value map of attribute properties</span>
<span class="c">         * @param {Boolean} init Whether or not this should become the intial config.</span>
<span class="c">         */</span>
        <span class="nx">setAttributeConfig</span><span class="o">:</span> <span class="k">function</span><span class="o">(</span><span class="nx">key</span><span class="o">,</span> <span class="nx">map</span><span class="o">,</span> <span class="nx">init</span><span class="o">)</span> <span class="o">{</span>
            <span class="k">var</span> <span class="nx">configs</span> <span class="o">=</span> <span class="k">this</span><span class="o">.</span><span class="nx">_configs</span> <span class="o">||</span> <span class="o">{};</span>
            <span class="nx">map</span> <span class="o">=</span> <span class="nx">map</span> <span class="o">||</span> <span class="o">{};</span>
            <span class="k">if</span> <span class="o">(!</span><span class="nx">configs</span><span class="o">[</span><span class="nx">key</span><span class="o">])</span> <span class="o">{</span>
                <span class="nx">map</span><span class="o">.</span><span class="nx">name</span> <span class="o">=</span> <span class="nx">key</span><span class="o">;</span>
                <span class="nx">configs</span><span class="o">[</span><span class="nx">key</span><span class="o">]</span> <span class="o">=</span> <span class="k">new</span> <span class="nx">YAHOO</span><span class="o">.</span><span class="nx">util</span><span class="o">.</span><span class="nx">Attribute</span><span class="o">(</span><span class="nx">map</span><span class="o">,</span> <span class="k">this</span><span class="o">);</span>
            <span class="o">}</span> <span class="k">else</span> <span class="o">{</span>
                <span class="nx">configs</span><span class="o">[</span><span class="nx">key</span><span class="o">].</span><span class="nx">configure</span><span class="o">(</span><span class="nx">map</span><span class="o">,</span> <span class="nx">init</span><span class="o">);</span>
            <span class="o">}</span>
        <span class="o">},</span>
        
        <span class="c">/**</span>
<span class="c">         * Sets or updates an Attribute instance&#39;s properties. </span>
<span class="c">         * @method configureAttribute</span>
<span class="c">         * @param {String} key The attribute&#39;s name.</span>
<span class="c">         * @param {Object} map A key-value map of attribute properties</span>
<span class="c">         * @param {Boolean} init Whether or not this should become the intial config.</span>
<span class="c">         */</span>
        <span class="nx">configureAttribute</span><span class="o">:</span> <span class="k">function</span><span class="o">(</span><span class="nx">key</span><span class="o">,</span> <span class="nx">map</span><span class="o">,</span> <span class="nx">init</span><span class="o">)</span> <span class="o">{</span>
            <span class="k">this</span><span class="o">.</span><span class="nx">setAttributeConfig</span><span class="o">(</span><span class="nx">key</span><span class="o">,</span> <span class="nx">map</span><span class="o">,</span> <span class="nx">init</span><span class="o">);</span>
        <span class="o">},</span>
        
        <span class="c">/**</span>
<span class="c">         * Resets an attribute to its intial configuration. </span>
<span class="c">         * @method resetAttributeConfig</span>
<span class="c">         * @param {String} key The attribute&#39;s name.</span>
<span class="c">         * @private</span>
<span class="c">         */</span>
        <span class="nx">resetAttributeConfig</span><span class="o">:</span> <span class="k">function</span><span class="o">(</span><span class="nx">key</span><span class="o">){</span>
            <span class="k">var</span> <span class="nx">configs</span> <span class="o">=</span> <span class="k">this</span><span class="o">.</span><span class="nx">_configs</span> <span class="o">||</span> <span class="o">{};</span>
            <span class="nx">configs</span><span class="o">[</span><span class="nx">key</span><span class="o">].</span><span class="nx">resetConfig</span><span class="o">();</span>
        <span class="o">},</span>
        
        <span class="c">/**</span>
<span class="c">         * Fires the attribute&#39;s beforeChange event. </span>
<span class="c">         * @method fireBeforeChangeEvent</span>
<span class="c">         * @param {String} key The attribute&#39;s name.</span>
<span class="c">         * @param {Obj} e The event object to pass to handlers.</span>
<span class="c">         */</span>
        <span class="nx">fireBeforeChangeEvent</span><span class="o">:</span> <span class="k">function</span><span class="o">(</span><span class="nx">e</span><span class="o">)</span> <span class="o">{</span>
            <span class="k">var</span> <span class="nx">type</span> <span class="o">=</span> <span class="s1">&#39;before&#39;</span><span class="o">;</span>
            <span class="nx">type</span> <span class="o">+=</span> <span class="nx">e</span><span class="o">.</span><span class="nx">type</span><span class="o">.</span><span class="nx">charAt</span><span class="o">(</span><span class="m">0</span><span class="o">).</span><span class="nx">toUpperCase</span><span class="o">()</span> <span class="o">+</span> <span class="nx">e</span><span class="o">.</span><span class="nx">type</span><span class="o">.</span><span class="nx">substr</span><span class="o">(</span><span class="m">1</span><span class="o">)</span> <span class="o">+</span> <span class="s1">&#39;Change&#39;</span><span class="o">;</span>
            <span class="nx">e</span><span class="o">.</span><span class="nx">type</span> <span class="o">=</span> <span class="nx">type</span><span class="o">;</span>
            <span class="k">return</span> <span class="k">this</span><span class="o">.</span><span class="nx">fireEvent</span><span class="o">(</span><span class="nx">e</span><span class="o">.</span><span class="nx">type</span><span class="o">,</span> <span class="nx">e</span><span class="o">);</span>
        <span class="o">},</span>
        
        <span class="c">/**</span>
<span class="c">         * Fires the attribute&#39;s change event. </span>
<span class="c">         * @method fireChangeEvent</span>
<span class="c">         * @param {String} key The attribute&#39;s name.</span>
<span class="c">         * @param {Obj} e The event object to pass to the handlers.</span>
<span class="c">         */</span>
        <span class="nx">fireChangeEvent</span><span class="o">:</span> <span class="k">function</span><span class="o">(</span><span class="nx">e</span><span class="o">)</span> <span class="o">{</span>
            <span class="nx">e</span><span class="o">.</span><span class="nx">type</span> <span class="o">+=</span> <span class="s1">&#39;Change&#39;</span><span class="o">;</span>
            <span class="k">return</span> <span class="k">this</span><span class="o">.</span><span class="nx">fireEvent</span><span class="o">(</span><span class="nx">e</span><span class="o">.</span><span class="nx">type</span><span class="o">,</span> <span class="nx">e</span><span class="o">);</span>
        <span class="o">}</span>
    <span class="o">};</span>
    
    <span class="nx">YAHOO</span><span class="o">.</span><span class="nx">augment</span><span class="o">(</span><span class="nx">YAHOO</span><span class="o">.</span><span class="nx">util</span><span class="o">.</span><span class="nx">AttributeProvider</span><span class="o">,</span> <span class="nx">YAHOO</span><span class="o">.</span><span class="nx">util</span><span class="o">.</span><span class="nx">EventProvider</span><span class="o">);</span>
<span class="o">})();</span>
</pre></div>
                    </div>
			</div>
		</div>
		<div class="yui-b">
            <div class="nav">

                    <div class="module">
                        <h4>Modules</h4>
                        <ul class="content">

                                <li class=""><a href="module_animation.html">animation</a></li>

                                <li class=""><a href="module_autocomplete.html">autocomplete</a></li>

                                <li class=""><a href="module_button.html">button</a></li>

                                <li class=""><a href="module_calendar.html">calendar</a></li>

                                <li class=""><a href="module_connection.html">connection</a></li>

                                <li class=""><a href="module_container.html">container</a></li>

                                <li class=""><a href="module_datasource.html">datasource</a></li>

                                <li class=""><a href="module_datatable.html">datatable</a></li>

                                <li class=""><a href="module_dom.html">dom</a></li>

                                <li class=""><a href="module_dragdrop.html">dragdrop</a></li>

                                <li class="selected"><a href="module_element.html">element</a></li>

                                <li class=""><a href="module_event.html">event</a></li>

                                <li class=""><a href="module_history.html">history</a></li>

                                <li class=""><a href="module_logger.html">logger</a></li>

                                <li class=""><a href="module_menu.html">menu</a></li>

                                <li class=""><a href="module_slider.html">slider</a></li>

                                <li class=""><a href="module_tabview.html">tabview</a></li>

                                <li class=""><a href="module_treeview.html">treeview</a></li>

                                <li class=""><a href="module_yahoo.html">yahoo</a></li>
                        </ul>
                    </div>

                    <div class="module">
                        <h4>Classes</h4>
                        <ul class="content">
                                <li class=""><a href="YAHOO.util.Attribute.html">YAHOO.util.Attribute</a></li>
                                <li class=""><a href="YAHOO.util.AttributeProvider.html">YAHOO.util.AttributeProvider</a></li>
                                <li class=""><a href="YAHOO.util.Element.html">YAHOO.util.Element</a></li>
                        </ul>
                    </div>

                    <div class="module">
                        <h4>Files</h4>
                        <ul class="content">        
                                <li class=""><a href="Attribute.js.html">Attribute.js</a></li>
                                <li class="selected"><a href="AttributeProvider.js.html">AttributeProvider.js</a></li>
                                <li class=""><a href="Element.js.html">Element.js</a></li>
                        </ul>
                    </div>





            </div>
		</div>
	</div>
	<div id="ft">
        <hr />
        Copyright &copy; 2007 Yahoo! Inc. All rights reserved.
	</div>
</div>
</body>
</html>
